/**
 * @file
 * Handles JavaScript for the members widget of a private message thread.
 */
// @todo Raw conceptual logic of the intermediary layers.
// window.emit() ...
//
// -> form.dispatchEvent('procRecipients', [2, 3])
//
// Proc encrypt modal x 4
// <div data-proc-encrypted-for="[2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder</div>
// <div data-proc-encrypted-for="[2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder</div>
// <div data-proc-encrypted-for="[2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder</div>
// <div data-proc-encrypted-for="[2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder</div>
//
// Select --> Pas aan --> form.dispatchEvent('procRecipientsAdd', [1])
// recipients => [1,2,3]
// <div data-proc-encrypted-for="[2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder <a href="/ajax/recypt?uid=[1,2,3]>Encryption outdated, recrypt<a></div>
//
// Pas aan "ajax" --> Replace <div data-proc-encrypted-for="[1, 2,3]" data-proc-uuid="uuid-1">EncryptedContent placeholder</div>
//
// <form data-proc-validated="">
//    <div>
//       <input type="hidden" data-proc-target="" value="3"></input>
//       <div>
//         <delete trigger?> --> JS only, empties the field?
//       <div>
//       <div data-proc-recipients="[2,3]">
//          <div>Identity document.pdf</div>
//       </div>
//    </div>
//    <div>
//       <input type="hidden" data-proc-target="" value="NULL"></input>
//       <a data-proc-modal-trigger href="ajax/add/attachment?recipients=[2,3]">Upload file</a>
//    </div>
// </form>
(function (Drupal, drupalSettings, window, once) {
  'use strict';

  Drupal.behaviors.procApi = {
    attach: function (context) {
      // @todo, how best to store this? Note you need the source, so we can maintain a stable method.
      let procRecipientSources = [
        {source: "initial", values: []},
      ]

      // Sometimes the encryption requires some backend process to have already
      // been run. For example a form where the recipients are nolonger in a
      // form element. This supported by adding the initialRecipients key
      // to the drupalSettings.proc.encryption.initialRecipients
      // @todo support storing this somewhere.
      if (drupalSettings.proc.encryption.initialRecipients) {
        console.log(drupalSettings.proc.encryption.initialRecipients);
        // @todo, this should basically update the url get params.
        // add ?recipients=1,2,3 to it.
        document.querySelectorAll("a[data-proc-encrypt-link]").forEach((value) => {value.textContent = drupalSettings.proc.encryption.initialRecipients.join(', ')})
      }

      console.log('initializing proc api')
      console.log(drupalSettings)
      console.log(procRecipientSources)

      // Ajax command callback, this can be triggered by various back end
      // processes to ensure the frontend is aware of a set of recipients added
      // by various means.
      Drupal.AjaxCommands.prototype.procUpdateRecipients = function (ajax, response) {
        // @todo support storing the changes that are passed here.
        console.log(ajax)
        console.log(response)
        document.querySelectorAll("a[data-proc-encrypt-link]").forEach((value) => {value.textContent = response.recipients.join(', ')})
      };

      // Register items to watch based on the detection of a data-attribute.
      // @nice to have, backend decided way to "listen" to changes form the
      // various form elements.
      document.querySelectorAll("div[data-proc-encryption-recipients] input").forEach(
        (value) => {
          console.log(value)
          value.addEventListener('change',  (event) => {
            console.log('change event. (%s)', event);
          })}
      )

    },
    detach: function (context) {
    }
  };

}(Drupal, drupalSettings, window, once));
