<?php

namespace Drupal\proc\Entity\Handler;

use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\Core\Entity\Sql\SqlContentEntityStorage;
use Drupal\proc\Entity\KeyringStorageInterface;

/**
 * Storage handler for proc items.
 */
class ProcStorageHandler extends SqlContentEntityStorage implements EntityStorageInterface, KeyringStorageInterface {

  /**
   * {@inheritdoc}
   *
   * @todo account for disabled keyrings.
   * @todo account for keyrings with insufficiently strong ciphers.
   * @todo split keyrings and ciphers to separate entities since they have
   *   completely different uses.
   */
  public function queryByUsers(array $userIds = []) : array {
    $query = $this->getQuery();
    return $query->accessCheck(FALSE)
      ->condition('user_id', $userIds, 'IN')
      ->condition('type', 'cipher', '!=')
      ->execute();
  }

}
