<?php

namespace Drupal\proc\Entity;

/**
 * Keyring storage interface.
 *
 * Keyrings are an 'armored' storage of a users pasword/user combination used
 * to encode/decode ciphers.
 *
 * @todo these should be split to separate entities. So this is already implemented as a separate interface. For easier refactoring down the line.
 */
interface KeyringStorageInterface {

  /**
   * Query a list of all recipients based on a set of user ids.
   *
   * @param int[] $userIds
   *   The user id's to get the keyrings for.
   *
   * @return int[]
   *   Any keyring ids connected to these users.
   */
  public function queryByUsers(array $userIds = []) : array;

}
