<?php

namespace Drupal\proc\Form\Encrypt;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\proc\ProcKeychainInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Open a modal form to encrypt an uploaded file.
 */
abstract class AbstractEncryptionForm extends FormBase {

  protected ProcKeychainInterface $keychain;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static($container->get('proc.keychain'));
  }

  public function __construct(ProcKeychainInterface $keychain) {
    $this->keychain = $keychain;
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    // Add some hidden fields for specific hidden data relevant for this
    // item.
    $form['cipher_text'] = ['#type' => 'hidden'];
    $form['source_file_name'] = ['#type' => 'hidden'];
    $form['source_file_size'] = ['#type' => 'hidden'];
    $form['source_file_type'] = ['#type' => 'hidden'];
    $form['source_file_last_change'] = ['#type' => 'hidden'];
    $form['browser_fingerprint'] = ['#type' => 'hidden'];
    $form['generation_timestamp'] = ['#type' => 'hidden'];
    $form['generation_timespan'] = ['#type' => 'hidden'];
    $form['signed'] = ['#type' => 'hidden'];

    return $form;
  }

}
