<?php

namespace Drupal\proc;

/**
 * Service that represents a keychain for a user or group of users.
 *
 * This provides an internalized way of checking user keychain information etc.
 */
interface ProcKeychainInterface {

  /**
   * Checks or a user has a valid/active keyring.
   *
   * @todo add support for the keyring strength.
   *
   * @param int $userId
   *   The user id to check.
   *
   * @return bool
   *   Flag indicating the user has a keyring.
   */
  public function hasKeyring(int $userId) : bool;

}
